const encryptUser = require('../../../utils/encryptUser')
const jwt = require('jsonwebtoken')

module.exports = async function (payload) {
	const {
		token,
		body = {}
	} = payload

	const {
		email,
		password
	} = body

	const {secret} = this.mycellium

	let account

	try {
		if (email && password) {
			if (secret) {
				account = await this.Model.findOne(encryptUser({email, password}, secret))
			} else {
				throw 'No secret'
			}
		}

		if (token && !account) {
			const decoded = jwt.verify(token, secret)
			account = await this.Model.findById(decoded._id)
		}

		if (account) {
			account = account.toObject()
			delete account.__v
			delete account.salt

			return {
				...account,
				token: jwt.sign({_id: account._id, email: account.email}, secret)
			}
		} else {
			throw 'No account found'
		}
	} catch (error) {
		console.error(error)
		throw `Problem signing in: ${error || 'Invalid token'}`
	}
}