const Cell = require('../Cell/index')

class Event extends Cell {
	constructor (props) {
		super({
			...props,
			modulePath: __dirname,
			schema: require('./EventSchema')
		})

		this.createEvent = require('../_methods/event/createEvent').bind(this)
	}

	saveEvent(channel, message) {
		const {str} = message
		const split = str.split('.')

		const method = split[0]

		if (method !== 'INFORM') this.createEvent(message)
	}

	onMycelliumMessage(channel, message) {
		this.saveEvent(channel, message)
	}

	onCellMessage (channel, message) {
		this.saveEvent(channel, message)
	}
}

module.exports = Event