const uuidv4 = require('uuid/v4')

module.exports = function (message) {
  const {account} = message

  if (account && account.email === this.mycellium.admin) {
    if (this.config.monitorOn) {
      this.config.monitorOn = false
      clearInterval(this.monitorInterval)

    } else {
      this.config.monitorOn = true

      if (this.config.monitorResources) {
        this.monitorInterval = setInterval(() => {
          Object.keys(this.mycellium.services).forEach(service => {
            if (service === 'Monitor') return

            this.publish({
              id: uuidv4(),
              str: `GET.${service}.Service._monitor`
            })
          })
        }, this.config.monitorInterval || 500)
      }

    }

    return {
      monitorOn: this.config.monitorOn
    }
  } else {
    throw 'Unauthorized'
  }
}