const Cell = require('../Cell')
// const kue = require('kue')
// const _broadcast = require('./Service/_broadcast')
const redis = require('redis')
const client = redis.createClient()
const instance = process.env.NODE_APP_INSTANCE

/*const emit = function (socketId, payload) {
	// const {str} = message
	const io = require('socket.io-emitter')({host: 'localhost', port: 6379})

	io.to(socketId).emit('message', payload)

	const name = `${this.name}${typeof instance !== 'undefined' ? `_${instance}` : ''}`

	console.log(`${`${name} [>>] ${socketId} ${payload.length} events`.bgMagenta.black} 👁`)
}

const broadcast = async function (message, socketId) {
	return new Promise(resolve => {
		client.get('events', async (err, events) => {
			if (!events) {
				await client.set('events', JSON.stringify([]))
			} else {
				const _events = JSON.parse(events)

				if (_events.length === 20) {
					clearTimeout(this.socketTimeout)
					await client.set('events', JSON.stringify([]))
					await emit.call(this, socketId, _events)

					this.socketTimeout = setTimeout(() => {
						client.get('events', async (err, events) => {
							const _events = JSON.parse(events)
							await emit.call(this, socketId, _events)
						})
					}, 3000)
				} else {
					await client.set('events', JSON.stringify([..._events, message]))
				}
			}
			resolve()
		})
	})
}*/

class Monitor extends Cell {
	constructor (props) {
		super({
			...props,
			modulePath: __dirname,
			monitorOn: true,
			schema: require('./MonitorSchema')
		})

		/*this.queue = kue.createQueue()
		this.queue.process('broadcast', 1, async (job, done) => {
			const {message, socketId} = job.data

			await broadcast.call(this, message, socketId)

			done()
		})*/
	}

	async broadcast (channel, message) {
		const {str} = message
		const split = str.split('.')
		const method = split[0]

		await client.get('adminSocket', (err, socketId) => {
			if (!err && socketId) {
				console.log('SOCKET FOUND: ', socketId)

				if (method !== 'INFORM') {
					const job = this.queue.create('broadcast', {
						channel,
						message,
						socketId
					})

					job.on('complete', function (result) {
						console.log(`create job completed broadcast ${job.id}`)
					}).on('failed', function () {
						console.log(`Job failed`)
					})

					job
						.removeOnComplete(true)
						.save((err) => {
							if (!err) console.log('new job', job.id)
						})
				}
			}
		})
	}

	async onMycelliumMessage (channel, message) {
		if (this.Model) await this.storeEvent.call(this, message)
	}

	async onCellMessage (channel, message) {
		if (this.Model) await this.storeEvent.call(this, message)
	}

	async storeEvent (message) {
		const {id, str, body, socketId, ip, time, account} = message
		const split = str.split('.')
		const method = split[0]
		const service = split[1]
		const section = split[2]
		const action = split[3]
		const event = split[4]

		if (method !== 'INFORM') {
			if (event) {
				await this.Model.findOneAndUpdate({id}, {
					response: JSON.stringify(message)
				})
			} else {
				await this.Model.create({
					id,
					accountId: account ? account._id : undefined,
					socketId,
					ip,
					method,
					service,
					section,
					action,
					event,
					time,
					body: JSON.stringify(body),
					instance
				})
			}
		}
	}
}

module.exports = Monitor