import React from 'react'
import classnames from 'classnames'
import config from '../../config'
import './Header.scss'

export default ({tab, onTabClick, reset}) => {
	return (
		<header>
			<div className="logo">
				Monitor
			</div>

			<nav>
				{config.nav.map(item => {
					return (
						<button
							key={item}
							className={classnames({'active': tab === item})}
							onClick={() => {
								onTabClick(item)
							}}
						>
							{item}
							</button>
					)
				})}
			</nav>

			<div className="actions">
				<button onClick={reset}>Clear</button>
			</div>
		</header>
	)
}