import React, { Component } from 'react'
import {observer} from 'mobx-react'
import './Login.scss'
import request from '../../../../../utils/request'

@observer
export default class Login extends Component {
	state = {
		email: '',
		password: '',
		loading: false
	}

	async onSubmit (e) {
		e.preventDefault()
		const {email, password} = this.state

		const response = await request(mycelliumClient, {
			str: 'SET.Account.Service.login',
			body: {
				email,
				password
			}
		})
		console.log(response.body.token);
		this.props.store.admin.token = response.body.token

		monitorClient.emit('account', {
			token: response.body.token
		})
	}

	inputChange(e) {
		const {name, value} = e.target

		this.setState({
			...this.state,
			[name]: value
		})
	}

	render () {
		const {email, password} = this.state

		return (
			<section id='Login'>
				<form onSubmit={this.onSubmit.bind(this)}>
					<div className="row">
						<label htmlFor="email-input">Email</label>
						<input type="text" name="email" id="email-input" value={email} onChange={this.inputChange.bind(this)}/>
					</div>
					<div className="row">
						<label htmlFor="password-input">Password</label>
						<input type="password" name="password" id="password-input" value={password} onChange={this.inputChange.bind(this)}/>
					</div>
					<div className="row">
						<button type="submit" disabled={email === '' || password === ''}>Login</button>
					</div>
				</form>
			</section>
		)
	}
}