import React, { Component } from 'react'
import { observer } from 'mobx-react'
import MonitorOn from './MonitorOn'
import MonitorOff from './MonitorOff'
import './Monitor.scss'

@observer
export default class Monitor extends Component {
	componentDidMount () {
		monitorClient.on('account', message => {
			console.log(message);
			this.props.store.monitorOn = message.monitorOn
			this.props.store.admin = {
				...this.props.store.admin,
				...message.account
			}
		})
	}

	render () {
		const {store} = this.props
		const {monitorOn, admin} = store
		const loggedIn = admin && admin && admin._id

		return (
			<section id='Monitor'>
				{loggedIn && monitorOn ? <MonitorOn store={store}/> : <MonitorOff store={store}/>}
			</section>
		)
	}
}