import React from 'react'

import Input from '../../../components/Input/Input.jsx'
import Checkbox from '../../../components/Checkbox/Checkbox.jsx'
import Wizard from '../../../components/Wizard/Wizard.jsx'
import WizardStep from '../../../components/Wizard/WizardStep.jsx'

import AccountIcon from '../../../icons/account.svg'
import EmailIcon from '../../../icons/email.svg'
import SetupIcon from '../../../icons/setup.svg'
import StartedIcon from '../../../icons/started.svg'

export default () => (
    <div id="signup">
        <Wizard>
            <WizardStep
                name="createAccount"
                title="Create an Account"
                icon={<AccountIcon/>}
            >
                <Input type="text" placeholder="Username"/>
                <Input type="password" placeholder="Password"/>
                <Input type="email" placeholder="Email"/>
                <Input type="text" placeholder="Company Name"/>

                <div className="connect-as">
                    <div>Want to connect as:</div>
                    <div>
                        <div>
                            <Checkbox
                                id="demandPartner"
                                name="demandPartner"
                                label="Demand partner"
                            />
                        </div>

                        <div>
                            <Checkbox
                                id="supplyPartner"
                                name="supplyPartner"
                                label="Supply partner"
                            />
                        </div>
                    </div>
                </div>
                <div className="terms-agreement">
                    <Checkbox
                        id="termsAgreement"
                        name="termsAgreement"
                        label={<span>Agree to <a href="">Terms &amp; Conditions</a></span>}
                    />
                </div>
            </WizardStep>
            <WizardStep
                name="emailConfirmation"
                title="Email Confirmation"
                icon={<EmailIcon/>}
                className="email-confirmation"
            >
                <h2>Thank you!</h2>
                <p>Please check your inbox to activate your subscription</p>
            </WizardStep>
            <WizardStep
                name="accountSetup"
                title="Account Setup"
                icon={<SetupIcon />}
            >

            </WizardStep>
            <WizardStep
                name="gettingStarted"
                title="Getting Started"
                icon={<StartedIcon />}
            >

            </WizardStep>
        </Wizard>
    </div>
)