import React, { Component } from 'react'
import classnames from 'classnames'
import './Welcome.scss'

import Signup from './Signup/Signup.jsx'
import Signin from './Signin/Signin.jsx'

export default class Welcome extends Component {
  state = {
    page: 'signup'
  }

  setPage (e, page) {
    e && e.preventDefault()
    this.setState({page})
  }

  render () {
    const {page} = this.state

    return (
      <section id="welcome" className="page">
        <div className="page-body">
          <div>
            <h1>Welcome</h1>
            <h2>HERE Mobility developer zone</h2>

            <nav>
              <a href="" className={classnames({'selected': page === 'signin'})} onClick={e => {
                this.setPage(e, 'signin')
              }}>Login</a>
              <a href="" className={classnames({'selected': page === 'signup'})} onClick={e => {
                this.setPage(e, 'signup')
              }}>Sign up</a>
            </nav>

            {page === 'signin' && <Signin/>}
            {page === 'signup' && <Signup/>}
          </div>
        </div>
      </section>
    )
  }
}