import request from '../../../../../utils/request'

const LOGIN = 'SET.Account.Service.Login'
export const LOGIN_SUCCESS = `${LOGIN}_SUCCESS`
export const LOGIN_ERROR = `${LOGIN}_ERROR`
export const EVENT_IN = `EVENT_IN`
export const RESET = `RESET`

/*export const mycelliumConnect = (io) => {
	return {
		type: 'Mycellium.Connect',
		io
	}
}

export const monitorConnect = (io) => {
	return {
		type: 'Monitor.Connect',
		io
	}
}*/

export const login = ({email, password}) => {
	return async dispatch => {
		try {
			const response = await request(mycelliumClient, {
				str: 'SET.Account.Service.login',
				body: {
					email,
					password
				}
			})

			monitorClient.emit('account', {
				token: response.body.token
			})

			// return dispatch(loginFx(response.body))
			// dispatch(loginSuccess(response.body))
		} catch (error) {
			return dispatch(loginError(error))
		}
	}
}

/*const monitorAdminConnect = (admin, token, dispatch) => {
	return new Promise((resolve, reject) => {
		admin.monitorClient.emit('account', {
			token
		})

		admin.monitorClient.on('account', message => {
			resolve(message)
		})

		admin.monitorClient.on('message', message => {
			console.log(message)
			dispatch(eventIn(message))
		})
	})
}*/

export const eventIn = (payload) => {
	return {
		type: EVENT_IN,
		payload
	}
}

export const reset = (payload) => {
	return {
		type: RESET,
		payload
	}
}

/*const loginFx = (payload) => {
	return async (dispatch, getState) => {
		const {admin} = getState()

		try {
			await monitorAdminConnect(admin, payload.token, dispatch)

			dispatch(loginSuccess(payload))
		} catch(error) {
			console.error(error)
		}
	}
}*/

export const loginSuccess = (payload) => {
	return {
		type: LOGIN_SUCCESS,
		payload
	}
}

const loginError = (error) => {
	return {
		type: LOGIN_ERROR,
		error
	}
}

export default {
	// mycelliumConnect,
	login
}