const __DEV__ = process.env.NODE_ENV === 'development'

import { createStore, applyMiddleware, compose } from 'redux'
import rootReducer from './reducers/index'
import thunkMiddleware from 'redux-thunk'

const enhancer = compose(
  applyMiddleware(thunkMiddleware),
  __DEV__ && window.__REDUX_DEVTOOLS_EXTENSION__ ? window.__REDUX_DEVTOOLS_EXTENSION__() : f => f
)

export default function configureStore (initialState) {
  const store = createStore(rootReducer, initialState, enhancer)

  if (module.hot) {
    module.hot.accept('./reducers/index', () =>
      store.replaceReducer(require('./reducers/index'))
    )
  }

  return store
}