const path = require('path')
const webpack = require('webpack')

module.exports = {
  plugins: [
    new webpack.NamedModulesPlugin(),
    new webpack.optimize.OccurrenceOrderPlugin(),
    new webpack.NoEmitOnErrorsPlugin()
  ],
  stats: {
    warnings: false
  },
  resolve: {
    extensions: ['.js', '.jsx']
  },
  module: {
    rules: [
      {
        test: /\.svg$/,
        exclude: /node_modules/,
        loaders: ['svg-react-loader']
      },
      {
        test: /\.(png|jpg|gif)$/,
        use: [
          {
            loader: 'url-loader',
            options: {
              limit: 9000
            }
          }
        ]
      }
    ]
  }
}