const path = require('path');
const webpack = require('webpack');
const merge = require('webpack-merge');
const common = require('./common');

module.exports = merge(common, {
  devtool: 'cheap-eval',
  mode: 'development',
  context: path.resolve(__dirname, '..'),
  entry: './src/index.js',
  output: {
    path: path.resolve(__dirname, '..', 'dist'),
    filename: 'bundle.js',
    // chunkFilename: '[name].bundle.js'
  },
  devServer: {
    contentBase: path.resolve(__dirname, '..')
  },
  module: {
    rules: [
      {
        test: /\.js|jsx$/,
        exclude: /node_modules/,
        use: {
          loader: 'babel-loader',
        }
      },
      {
        test: /\.scss$/,
        exclude: /node_modules/,
        loaders: ['style-loader', 'css-loader', 'sass-loader']
      },
    ]
  }
});