const path = require('path')

module.exports = {
	apps: [
		{
			name: 'Mycellium',
			script: path.resolve(__dirname, './Mycellium/Mycellium.js'),
			watch: true,
			instances: '2',
			exec_mode: 'cluster',
			secret: 'Myc3llium',
			admin: 'admin@mycellium.io',
			monitor: true,
			port: 1123,
			mycologies: {
				local: {}
			}
		},
		{
			name: 'Account',
			script: path.resolve(__dirname, './Account/Account.js'),
			watch: true,
			instances: '2',
			exec_mode: 'cluster',
			port: 1235,
			host: '188.166.33.95',
			mycologies: {
				local: {
					db: 'mongodb://localhost:27017/local_Account'
				}
			}
		},
		/*{
			name: 'Offer',
			script: path.resolve(__dirname, './Offer/Offer.js'),
			port: 1125,
			mycologies: {
				local: {
					db: 'mongodb://localhost:27017/local_Offer'
				}
			}
		},
		{
			name: 'Match',
			script: path.resolve(__dirname, './Match/Match.js'),
			port: 1126,
			mycologies: {
				local: {
					db: 'mongodb://localhost:27017/local_Match'
				}
			}
		},*/
		{
			name: 'Monitor',
			script: path.resolve(__dirname, './Monitor/Monitor.js'),
			watch: true,
			instances: '2',
			exec_mode: 'cluster',
			port: 2235,
			mycologies: {
				local: {
					db: 'mongodb://localhost:27017/local_Monitor'
				}
			}
		}
	]
}
