const expect = require('chai').expect
const io = require('socket.io-client')
const request = require('../../../utils/request')

describe('Monitor', async () => {
	const mycelliumURL = 'http://localhost:1123'
	const monitorURL = 'http://localhost:1235'

	const mycelliumClient = io.connect(mycelliumURL)
	let monitorClient

	it('should succeed', done => {
		expect(true)
		done()
	})

	let admin = {
		email: 'admin@mycellium.io',
		password: '123456'
	}

	it('should register admin', async () => {
		const res = await request(mycelliumClient, {
			str: 'SET.Account.Service.register',
			body: admin
		})

		expect(res.body._id)
		expect(res.body.email).to.equal(admin.email)
	})

	it('should login into account', async () => {
		const res = await request(mycelliumClient, {
			str: 'SET.Account.Service.login',
			body: admin
		})

		admin.token = res.body.token
	})

	it('should register to monitor', async () => {
		monitorClient = io.connect(monitorURL, {query: `token=${admin.token}`})

		monitorClient.on('account', account => {
			console.log(account)
		})
	})

	it('should get requests events', async () => {
		monitorClient.on('message', message => {
			console.log(message)
		})

		const int = setInterval(async () => {
			const res = await request(mycelliumClient, {
				str: 'SET.Account.Service.login'
			})
		}, 200)
	})

	it('should succeed', (done) => {
		setTimeout(() => {
			done()
		}, 1000)
	})
})