const expect = require('chai').expect
const io = require('socket.io-client')
const request = require('../../../utils/request')

describe('Ping', async () => {
	const mycelliumURL = 'http://localhost:1123'
	const mycelliumClient = io.connect(mycelliumURL)

	it('should ping Mycellium', async () => {
		const res = await request(mycelliumClient, {
			str: 'GET.Mycellium.Service.ping'
		})

		expect(res.body.note)
	})

	it('should ping Offer', async () => {
		const res = await request(mycelliumClient, {
			str: 'GET.Offer.Service.ping'
		})

		expect(res.body.note)
	})

	it('should ping Account', async () => {
		const res = await request(mycelliumClient, {
			str: 'GET.Account.Service.ping'
		})

		expect(res.body.note)
	})
})