const expect = require('chai').expect
const io = require('socket.io-client')
const request = require('../../../utils/request')

let admin = {
	email: 'admin@mycellium.io',
	password: '123456'
}

describe('Ping', async () => {
	const mycelliumURL = 'http://localhost:1123'
	const mycelliumClient = io.connect(mycelliumURL)

	it('should deny _getAll', async () => {
		const res = await request(mycelliumClient, {
			str: 'SET.Offer.Model._getAll'
		})

		expect(res.body).to.equal('No token provided')
	})

	it('should login into account', async () => {
		const res = await request(mycelliumClient, {
			str: 'SET.Account.Service.login',
			body: admin
		})

		admin.token = res.body.token
	})

	it('should success _getAll', async () => {
		const res = await request(mycelliumClient, {
			str: 'SET.Offer.Model._getAll',
			token: admin.token
		})

		expect(res.body.length).to.not.equal(0)
	})
})