const expect = require('chai').expect
const io = require('socket.io-client')
const request = require('../../../utils/request')
const config = require('../TestApp/config')

describe('Mycellium Rate Limit', async () => {
	const mycelliumURL = 'http://localhost:1123'
	const mycelliumClient = io.connect(mycelliumURL)

	let MAX = config.rateLimit.rateMax + 1
	let TIME = 1

	for (let i = 0; i < MAX; i++) {
		it('should ping', async () => {
			await new Promise(resolve => {
				setTimeout(async () => {
					console.log(i)
					const response = await
						request(mycelliumClient, {
							str: 'GET.Mycellium.Service.ping'
						})

					if (i === 100) expect(response.body).to.be.equal('Rate limited')

					resolve()
				}, TIME)
			})
		})
	}
})

describe('Mycellium Rate Limit', async () => {
	const mycelliumURL = 'http://localhost:1123'
	const mycelliumClient = io.connect(mycelliumURL)

	let MAX = config.rateLimit.rateMax + 3
	let TIME = 100

	for (let i = 0; i < MAX; i++) {
		it('should ping', async () => {
			await new Promise(resolve => {
				setTimeout(async () => {
					console.log(i)
					await
						request(mycelliumClient, {
							str: 'GET.Mycellium.Service.ping'
						})

					resolve()
				}, TIME)
			})
		})
	}
})