const expect = require('chai').expect
const io = require('socket.io-client')
const request = require('../../../utils/request')

let user = {
	email: 'user1@mycellium.io',
	password: '123456'
}

describe('register', async () => {
	const mycelliumURL = 'http://localhost:1123'
	const mycelliumClient = io.connect(mycelliumURL)

	let offerRes

	it('should login user', async () => {
		const res = await request(mycelliumClient, {
			str: 'SET.Account.Service.login',
			body: user
		})

		user.token = res.body.token
	})

	it('should create Offer', async () => {
		const res = await request(mycelliumClient, {
			str: 'SET.Offer.Model.&create',
			body: {
				title: 'test offer'
			},
			token: user.token
		})

		offerRes = res

		expect(res.body._id && res.body.title)
	})

	it('should create Match', async () => {
		mycelliumClient.on(`${offerRes.id}@reactions`, function (message) {
			expect(message.body._id)
		})
	})

	it('should timeout', done => {
		setTimeout(() => {
			done()
		}, 500)
	})
})