const socketResponse = require('../sockets/socketResponse')

const onCellMessage = async function (channel, message) {
	const _message = JSON.parse(message)
	const {id, str, ip, account, socketId, body} = _message

	const instance = process.env.NODE_APP_INSTANCE
	const name = `${this.name}${typeof instance !== 'undefined' ? `_${instance}` : ''}`

	const split = str.split('.')
	const cell = split[1]
	const event = split[4]

	if (this.name !== cell) {
		console.log(`[<<] ${name} | ${str}`.blue)

		if (this.onCellMessage) await this.onCellMessage(channel, _message)

		if (event && this.name === 'Mycellium') {
			socketResponse.call(this, event, {
				id,
				socketId,
				ip,
				account,
				str: str.replace(`.${event}`, '')
			}, body)
		} else {
			cellReactions.call(this, _message)
		}
	}
}

const cellReactions = async function (_message) {
	const {str} = _message
	const split = str.split('.')

	const cell = split[1]
	const section = split[2]
	const action = split[3]
	const event = split[4]

	react.call(this, 'cell', cell, section, action, event, _message)
	react.call(this, 'module', cell, section, action, event, _message)
	react.call(this, 'self', cell, section, action, event, _message)
}

const react = async function (reactionType, cell, section, action, event, _message) {
	const reactions = `${reactionType}Reactions`
	const reaction1 = this[reactions]
		? this[reactions][cell]
			? this[reactions][cell][section]
				? this[reactions][cell][section][action]
				: undefined
			: undefined
		: undefined

	if (reaction1) {
		await reaction1.call(this, _message)
	}

	const reaction2 = this[reactions]
		? this[reactions][cell]
			? this[reactions][cell][section]
				? this[reactions][cell][section][`${action}.${event}`]
				: undefined
			: undefined
		: undefined

	if (reaction2) {
		await reaction2.call(this, _message)
	}

	const reaction3 = this[reactions]
		? this[reactions][section]
			? this[reactions][section][action]
			: undefined
		: undefined

	if (reaction3) {
		await reaction3.call(this, _message)
	}
	const reaction4 = this[reactions]
		? this[reactions][section]
			? this[reactions][section][`${action}.${event}`]
			: undefined
		: undefined

	if (reaction4) {
		await reaction4.call(this, _message)
	}
}

module.exports = onCellMessage