const onMycelliumEvent = async function (message) {
	const {str} = message
	const split = str.split('.')

	const cell = split[1]
	// const event = split[4]
	const section = split[2]
	const action = split[3]

	let promises = []

	if (cell === this.name) {
		if (this.cellActions) {
			const cellAction = this.cellActions[section]
				? this.cellActions[section][action]
					? this.cellActions[section][action]
					: undefined
				: undefined

			if (cellAction) promises.push(cellAction.call(this, message))
		}

		if (this.moduleActions) {
			const moduleAction = this.moduleActions[section]
				? this.moduleActions[section][action]
					? this.moduleActions[section][action]
					: undefined
				: undefined

			if (moduleAction) promises.push(moduleAction.call(this, message))
		}

		if (this.selfActions) {
			const selfAction = this.selfActions[section]
				? this.selfActions[section][action]
					? this.selfActions[section][action]
					: undefined
				: undefined

			if (selfAction) promises.push(selfAction.call(this, message))
		}

		const results = await Promise.all(promises)

		if (results.length === 1) {
			return results[0]
		} else {
			return results
		}

	}
}

module.exports = onMycelliumEvent