const redis = require('redis')

const onMycelliumMessage = require('./onMycelliumMessage')

const subscribeToMycellium = function () {
	return new Promise((resolve, reject) => {
		let host = 'localhost'
		if (this.mycellium && this.mycellium.mycologies && this.mycellium.mycologies[this.env] && this.mycellium.mycologies[this.env].host) {
			host = this.mycellium.mycologies[this.env].host
		}

		const instance = process.env.NODE_APP_INSTANCE
		const channel = `Mycellium${typeof instance !== 'undefined' ? `_${instance}` : ''}`
		const name = `${this.name}${typeof instance !== 'undefined' ? `_${instance}` : ''}`

		this.subscribers[channel] = redis.createClient(6379, host)

		this.subscribers[channel].on('message', (channel, message) => {
			onMycelliumMessage.call(this, channel, message)
		})

		this.subscribers[channel].subscribe(channel, (error) => {
			if (!error) resolve()
		})

		console.log(`√ ${name} | Subscribed to ${channel} [${host}]`)
	})
}

module.exports = subscribeToMycellium