const redis = require('redis')

const setPublisher = function () {
	this.publisher = redis.createClient()

	const instance = process.env.NODE_APP_INSTANCE
	const name = `${this.name}${typeof instance !== 'undefined' ? `_${instance}` : ''}`

	console.log(`√ ${name} | Publisher set`)

	this.publish = (message) => {
		const {id, str} = message
		if (!id) throw `No id provided for request ${str}`

		this.publisher.publish(name, JSON.stringify(message))
	}
}

module.exports = setPublisher