require('colors')
const express = require('express')
const fs = require('fs')
const path = require('path')

module.exports = async function () {
	return new Promise(resolve => {
		this.app = new express()
		this.app.use(require('body-parser').json())

		this.app.get('/backup/:month', (req, res) => {
			const {month} = req.params

			const backupPath = path.resolve(this.config.selfPath, `backup.${month}.tar`)
			const exists = fs.existsSync(backupPath)

			if (!exists) {
				res.send({
					error: 'No such backup'
				})
			} else {
				res.download(backupPath)
			}
		})

		const port = Number(this.config.port)-1

		this.app.listen(port, () => {
			const instance = process.env.NODE_APP_INSTANCE
			const name = `${this.name}${typeof instance !== 'undefined' ? `_${instance}` : ''}`

			console.log(`√ ${name} | Express server listening (:${port})`.green)
			resolve({success: true})
		})
	})
}