const rateLimit = function (socket) {
	let rateError
	const now = new Date()

	if (this.floods[socket.id].lastClear === undefined) {
		this.floods[socket.id].lastClear = now
	}

	if (Math.abs(now - this.floods[socket.id].lastClear) > this.config.rateLimit.rateTime) {
		this.floods[socket.id] = {
			rateCount: 0,
			lastClear: now
		}
	}

	this.floods[socket.id].rateCount === undefined ? this.floods[socket.id].rateCount = 0 : this.floods[socket.id].rateCount
	this.floods[socket.id].rateCount++

	if (this.floods[socket.id].rateCount > this.config.rateLimit.rateMax) {
		rateError = 'Rate limited'
	}

	return rateError
}

module.exports = rateLimit