require('colors')

const socketResponse = function (event, message, body) {
	const {socketId} = message
	const {sockets} = this.io.sockets

	const socket = sockets[socketId]

	if (socket) {
		console.log('SOCKET FOUND: ', socketId)

		if (!event) throw 'event is missing'
		const {id, str} = message

		socket.emit(id, {
			str: `${str}.${event}`,
			body: body || message.body
		})

		const instance = process.env.NODE_APP_INSTANCE
		const name = `${this.name}${typeof instance !== 'undefined' ? `_${instance}` : ''}`

		console.log(` ${`${name} [>>] `.bgMagenta.black}${` ${str}.${event}`[event === 'SUCCESS' ? 'green' : 'red']['black']} `)
	}
}

module.exports = socketResponse