require('colors')
const express = require('express')
const http = require('http')
const redisAdapter = require('socket.io-redis');

module.exports = async function () {
	return new Promise(resolve => {
		this.app = new express()
		this.app.use(require('body-parser').json())
		this.http = http.Server(this.app)

		const {host = 'localhost'} = this.config.mycologies[this.env]

		const io = require('socket.io')(this.http)
		io.adapter(redisAdapter({ host, port: 6379 }));

		this.io = io
		this.io.on('connection', this.onSocketConnection)

		const port = this.config.port + Number(process.env.NODE_APP_INSTANCE || 0)
		const instance = process.env.NODE_APP_INSTANCE
		const name = `${this.name}${typeof instance !== 'undefined' ? `_${instance}` : ''}`

		this.http.listen(port, () => {
			console.log(`√ ${name} | Socket server listening (:${port})`.green)
			resolve({success: true})
		})
	})
}