module.exports = function(message) {
  const {id, socketId, str, body} = message

  const method = str.split('.')[0]    // GET / SET
  const cell = str.split('.')[1]
  const section = str.split('.')[2]
  const action = str.split('.')[3]
  const event = str.split('.')[4]     // SUCCESS / ERROR

  let error

  if (!socketId && !action === 'login') {
    error = `Missing socketId id`
    console.error(error)
  }

  /*if (!id) {
    error = `Missing socket request id`
    console.error(error)
  }*/

  if (str.split('.').length !== 4) {
    error = `Wrong message format`
    console.error(error)
  }

  if (method !== 'GET' && method !== 'SET' && method !== 'INFORM') {
    error = `Wrong method ${method}`
    console.error(error)
  }

  if (body && typeof body !== 'object') {
    error = `Wrong body format`
    console.error(error)
  }

  return error
}