const dropDatabase = require('./dropDatabase')

const dropAllDatabases = (config) => {
	const dbs = Object.keys(config.cells || {}).map(cell => {
		const {db} = config.cells[cell].mycologies[process.env.NODE_ENV || 'local']
		if (db) return db
	})
		.filter(db => db !== undefined)

	let promises = [
		...dbs.map(db => dropDatabase(db))
	]

	return Promise.all(promises)
}

module.exports = dropAllDatabases