const uuidv4 = require('uuid/v4')

const request = (client, message, timeout) => {
	return new Promise((resolve, reject) => {
		const id = message.id ? message.id : uuidv4()

		client.emit('request', Object.assign(message, {id}))

		client.on(id, function (message) {
			resolve(Object.assign({}, message, {id}))
		})

		if (timeout) {
			setTimeout(() => {
				reject(`Request ${id} timeout out (${timeout})`)
			}, timeout)
		}
	})
}

module.exports = request